| AAX SDK 2.6.1 Avid Audio Extensions Development Kit

- Welcome
- Manual
- Classes
- Files
- Lists
- Support

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
List of all members | Public Member Functions
AAX_IACFComponentDescriptor Class Referenceabstract

`#include <AAX_IACFComponentDescriptor.h>`

Inheritance diagram for AAX_IACFComponentDescriptor:
[legend]
Collaboration diagram for AAX_IACFComponentDescriptor:
[legend]

## Description

Versioned description interface for an AAX plug-in algorithm callback.

## Public Member Functions
virtual AAX_Result | Clear ()=0
| Clears the descriptor.
virtual AAX_Result | AddReservedField (AAX_CFieldIndex inFieldIndex, uint32_t inFieldType)=0
| Subscribes a context field to host-provided services or information.
virtual AAX_Result | AddAudioIn (AAX_CFieldIndex inFieldIndex)=0
| Subscribes an audio input context field.
virtual AAX_Result | AddAudioOut (AAX_CFieldIndex inFieldIndex)=0
| Subscribes an audio output context field.
virtual AAX_Result | AddAudioBufferLength (AAX_CFieldIndex inFieldIndex)=0
| Subscribes a buffer length context field.
virtual AAX_Result | AddSampleRate (AAX_CFieldIndex inFieldIndex)=0
| Subscribes a sample rate context field.
virtual AAX_Result | AddClock (AAX_CFieldIndex inFieldIndex)=0
| Subscribes a clock context field.
virtual AAX_Result | AddSideChainIn (AAX_CFieldIndex inFieldIndex)=0
| Subscribes a side-chain input context field.
virtual AAX_Result | AddDataInPort (AAX_CFieldIndex inFieldIndex, uint32_t inPacketSize, AAX_EDataInPortType inPortType)=0
| Adds a custom data port to the algorithm context.
virtual AAX_Result | AddAuxOutputStem (AAX_CFieldIndex inFieldIndex, int32_t inStemFormat, const char inNameUTF8[])=0
| Adds an auxiliary output stem for a plug-in.
virtual AAX_Result | AddPrivateData (AAX_CFieldIndex inFieldIndex, int32_t inDataSize, uint32_t inOptions=AAX_ePrivateDataOptions_DefaultOptions)=0
| Adds a private data port to the algorithm context.
virtual AAX_Result | AddDmaInstance (AAX_CFieldIndex inFieldIndex, AAX_IDma::EMode inDmaMode)=0
| Adds a DMA field to the plug-in's context.
virtual AAX_Result | AddMIDINode (AAX_CFieldIndex inFieldIndex, AAX_EMIDINodeType inNodeType, const char inNodeName[], uint32_t channelMask)=0
| Adds a MIDI node field to the plug-in's context.
virtual AAX_Result | AddProcessProc_Native (AAX_CProcessProc inProcessProc, IACFUnknown *inProperties, AAX_CInstanceInitProc inInstanceInitProc, AAX_CBackgroundProc inBackgroundProc, AAX_CSelector *outProcID)=0
| Registers an algorithm processing entrypoint (process procedure) for the native architecture.
virtual AAX_Result | AddProcessProc_TI (const char inDLLFileNameUTF8[], const char inProcessProcSymbol[], IACFUnknown *inProperties, const char inInstanceInitProcSymbol[], const char inBackgroundProcSymbol[], AAX_CSelector *outProcID)=0
| Registers an algorithm processing entrypoint (process procedure) for the native architecture.
virtual AAX_Result | AddMeters (AAX_CFieldIndex inFieldIndex, const AAX_CTypeID *inMeterIDs, const uint32_t inMeterCount)=0
| Adds a meter field to the plug-in's context.
Public Member Functions inherited from IACFUnknown
virtual BEGIN_ACFINTERFACE ACFRESULT ACFMETHODCALLTYPE | QueryInterface (const acfIID &iid, void **ppOut)=0
| Returns pointers to supported interfaces.
virtual acfUInt32 ACFMETHODCALLTYPE | AddRef (void)=0
| Increments reference count.
virtual acfUInt32 ACFMETHODCALLTYPE | Release (void)=0
| Decrements reference count.

## Member Function Documentation

## ◆ Clear()

virtual AAX_Result AAX_IACFComponentDescriptor::Clear | ( |  | ) |
| pure virtual

Clears the descriptor.

Clears the descriptor and readies it for the next algorithm description

## ◆ AddReservedField()

virtual AAX_Result AAX_IACFComponentDescriptor::AddReservedField | ( | AAX_CFieldIndex | inFieldIndex,
|  | uint32_t | inFieldType
| ) |  |
| pure virtual

Subscribes a context field to host-provided services or information.

Note
  Currently for internal use only.

Parameters

  [in] | inFieldIndex | Unique identifier for the field, generated using AAX_FIELD_INDEX
  [in] | inFieldType | Type of field that is being added

## ◆ AddAudioIn()

virtual AAX_Result AAX_IACFComponentDescriptor::AddAudioIn | ( | AAX_CFieldIndex | inFieldIndex | ) |
| pure virtual

Subscribes an audio input context field.

Defines an audio in port for host-provided information in the algorithm's context structure.

- Data type: float**
- Data kind: An array of float arrays, one for each input channel

Parameters

  [in] | inFieldIndex | Unique identifier for the field, generated using AAX_FIELD_INDEX

## ◆ AddAudioOut()

virtual AAX_Result AAX_IACFComponentDescriptor::AddAudioOut | ( | AAX_CFieldIndex | inFieldIndex | ) |
| pure virtual

Subscribes an audio output context field.

Defines an audio out port for host-provided information in the algorithm's context structure.

- Data type: float**
- Data kind: An array of float arrays, one for each output channel

Parameters

  [in] | inFieldIndex | Unique identifier for the field, generated using AAX_FIELD_INDEX

## ◆ AddAudioBufferLength()

virtual AAX_Result AAX_IACFComponentDescriptor::AddAudioBufferLength | ( | AAX_CFieldIndex | inFieldIndex | ) |
| pure virtual

Subscribes a buffer length context field.

Defines a buffer length port for host-provided information in the algorithm's context structure.

- Data type: int32_t*
- Data kind: The number of samples in the current audio buffer

Parameters

  [in] | inFieldIndex | Unique identifier for the field, generated using AAX_FIELD_INDEX

## ◆ AddSampleRate()

virtual AAX_Result AAX_IACFComponentDescriptor::AddSampleRate | ( | AAX_CFieldIndex | inFieldIndex | ) |
| pure virtual

Subscribes a sample rate context field.

Defines a sample rate port for host-provided information in the algorithm's context structure.

- Data type: AAX_CSampleRate *
- Data kind: The current sample rate

Parameters

  [in] | inFieldIndex | Unique identifier for the field, generated using AAX_FIELD_INDEX

## ◆ AddClock()

virtual AAX_Result AAX_IACFComponentDescriptor::AddClock | ( | AAX_CFieldIndex | inFieldIndex | ) |
| pure virtual

Subscribes a clock context field.

Defines a clock port for host-provided information in the algorithm's context structure.

- Data type: AAX_CTimestamp *

- Data kind: A running counter which increments even when the transport is not playing. The counter increments exactly once per sample quantum.

  Host Compatibility Notes:
    As of Pro Tools 11.1, this field may be used in both Native and DSP plug-ins. The DSP clock data is a 16-bit cycling counter. This field was only available for Native plug-ins in previous Pro Tools versions.

Parameters

  [in] | inFieldIndex | Unique identifier for the field, generated using AAX_FIELD_INDEX

## ◆ AddSideChainIn()

virtual AAX_Result AAX_IACFComponentDescriptor::AddSideChainIn | ( | AAX_CFieldIndex | inFieldIndex | ) |
| pure virtual

Subscribes a side-chain input context field.

Defines a side-chain input port for host-provided information in the algorithm's context structure.

- Data type: int32_t*
- Data kind: The index of the plug-in's first side-chain input channel within the array of input audio buffers

Parameters

  [in] | inFieldIndex | Unique identifier for the field, generated using AAX_FIELD_INDEX

## ◆ AddDataInPort()

virtual AAX_Result AAX_IACFComponentDescriptor::AddDataInPort | ( | AAX_CFieldIndex | inFieldIndex,
|  | uint32_t | inPacketSize,
|  | AAX_EDataInPortType | inPortType
| ) |  |
| pure virtual

Adds a custom data port to the algorithm context.

Defines a read-only data port for plug-in information in the algorithm's context structure. The plug-in can send information to this port using AAX_IController::PostPacket().

The host guarantees that all packets will be delivered to this port in the order in which they were posted, up to the point of a packet buffer overflow, though some packets may be dropped depending on the `inPortType` and host implementation.

Note
  When a plug-in is operating in offline (AudioSuite) mode, all data ports operate as AAX_eDataInPortType_Unbuffered ports

Parameters

  [in] | inFieldIndex | Unique identifier for the port, generated using AAX_FIELD_INDEX
  [in] | inPacketSize | Size of the data packets that will be sent to this port
  [in] | inPortType | The requested packet delivery behavior for this port

## ◆ AddAuxOutputStem()

virtual AAX_Result AAX_IACFComponentDescriptor::AddAuxOutputStem | ( | AAX_CFieldIndex | inFieldIndex,
|  | int32_t | inStemFormat,
|  | const char | inNameUTF8[]
| ) |  |
| pure virtual

Adds an auxiliary output stem for a plug-in.

Use this method to add additional output channels to the algorithm context.

The aux output stem audio buffers will be added to the end of the audio outputs array in the order in which they are described. When writing audio data to a specific aux output, find the proper starting channel by accumulating all of the channels of the main output stem format and any previously-described aux output stems.

The plug-in is responsible for providing a meaningful name for each aux outputs. At the very least, individual outputs should be labeled "Output xx", where "xx" is the aux output number as it is defined in the plug-in. The output name should also include the words "mono" and "stereo" to support when users are looking for an output with a specific stem format.

Host Compatibility Notes:
  There is a hard limit to the number of outputs that Pro Tools supports for a single plug-in instance. This limit is currently set at 256 channels, which includes all of the plug-in's output channels in addition to the sum total of all of its aux output stem channels.

Host Compatibility Notes:
  Pro Tools supports only mono and stereo auxiliary output stem formats

Warning
  This method will return an error code on hosts which do not support auxiliary output stems. This indicates that the host will not provide audio buffers for auxiliary output stems during processing. A plug-in must not attempt to write data into auxiliary output stem buffers which have not been provided by the host!

Parameters

  [in] | inFieldIndex | DEPRECATED: This parameter is no longer needed by the host, but is included in the interface for binary compatibility
  [in] | inStemFormat | The stem format of the new aux output
  [in] | inNameUTF8 | The name of the aux output. This name is static and cannot be changed after the descriptor is submitted to the host

## ◆ AddPrivateData()

virtual AAX_Result AAX_IACFComponentDescriptor::AddPrivateData | ( | AAX_CFieldIndex | inFieldIndex,
|  | int32_t | inDataSize,
|  | uint32_t | inOptions = `AAX_ePrivateDataOptions_DefaultOptions`
| ) |  |
| pure virtual

Adds a private data port to the algorithm context.

Defines a read/write data port for private state data. Data written to this port will be maintained by the host between calls to the algorithm context.

See also
  alg_pd_registration

Parameters

  [in] | inFieldIndex | Unique identifier for the port, generated using AAX_FIELD_INDEX
  [in] | inDataSize | Size of the data packets that will be sent to this port
  [in] | inOptions | Options that define the private data port's behavior

## ◆ AddDmaInstance()

virtual AAX_Result AAX_IACFComponentDescriptor::AddDmaInstance | ( | AAX_CFieldIndex | inFieldIndex,
|  | AAX_IDma::EMode | inDmaMode
| ) |  |
| pure virtual

Adds a DMA field to the plug-in's context.

DMA (direct memory access) provides efficient reads from and writes to external memory on the DSP. DMA behavior is emulated in host-based plug-ins for cross-platform portability.

Note
  The order in which DMA instances are added defines their priority and therefore order of execution of DMA operations. In most plug-ins, Scatter fields should be placed first in order to achieve the lowest possible access latency.

For more information, see Direct Memory Access .

Todo:
  Update the DMA system management such that operation priority can be set arbitrarily

Parameters

  [in] | inFieldIndex | Unique identifier for the field, generated using AAX_FIELD_INDEX
  [in] | inDmaMode | AAX_IDma::EMode that will apply to this field

## ◆ AddMIDINode()

virtual AAX_Result AAX_IACFComponentDescriptor::AddMIDINode | ( | AAX_CFieldIndex | inFieldIndex,
|  | AAX_EMIDINodeType | inNodeType,
|  | const char | inNodeName[],
|  | uint32_t | channelMask
| ) |  |
| pure virtual

Adds a MIDI node field to the plug-in's context.

- Data type: AAX_IMIDINode *

The resulting MIDI node data will be available both in the algorithm context and in the plug-in's data model via UpdateMIDINodes().

To add a MIDI node that is only accessible to the plug-in's data model, use AAX_IEffectDescriptor::AddControlMIDINode()

Host Compatibility Notes:
  Due to current restrictions MIDI data won't be delivered to DSP algorithms, only to AAX Native.

Parameters

  [in] | inFieldIndex | The ID of the port. MIDI node ports should formatted as a pointer to an AAX_IMIDINode.
  [in] | inNodeType | The type of MIDI node, as AAX_EMIDINodeType
  [in] | inNodeName | The name of the MIDI node as it should appear in the host's UI
  [in] | channelMask | The channel mask for the MIDI node. This parameter specifies used MIDI channels. For Global MIDI nodes, use a mask of AAX_EMidiGlobalNodeSelectors

## ◆ AddProcessProc_Native()

virtual AAX_Result AAX_IACFComponentDescriptor::AddProcessProc_Native | ( | AAX_CProcessProc | inProcessProc,
|  | IACFUnknown * | inProperties,
|  | AAX_CInstanceInitProc | inInstanceInitProc,
|  | AAX_CBackgroundProc | inBackgroundProc,
|  | AAX_CSelector * | outProcID
| ) |  |
| pure virtual

Registers an algorithm processing entrypoint (process procedure) for the native architecture.

Parameters

  [in] | inProcessProc | Symbol for this processing callback
  [in] | inProperties | A property map for this processing callback. The property map's values are copied by the host and associated with the new ProcessProc. The property map contents are unchanged and the map may be re-used when registering additional ProcessProcs.
  [in] | inInstanceInitProc | Initialization routine that will be called when a new instance of the Effect is created. See Algorithm initialization.
  [in] | inBackgroundProc | Background routine that will be called in an idle context within the same address space as the associated process procedure. See Background processing callback
  [out] | outProcID |

Todo:
  document this parameter

## ◆ AddProcessProc_TI()

virtual AAX_Result AAX_IACFComponentDescriptor::AddProcessProc_TI | ( | const char | inDLLFileNameUTF8[],
|  | const char | inProcessProcSymbol[],
|  | IACFUnknown * | inProperties,
|  | const char | inInstanceInitProcSymbol[],
|  | const char | inBackgroundProcSymbol[],
|  | AAX_CSelector * | outProcID
| ) |  |
| pure virtual

Registers an algorithm processing entrypoint (process procedure) for the native architecture.

Parameters

  [in] | inDLLFileNameUTF8 | UTF-8 encoded filename for the ELF DLL containing the algorithm code fragment
  [in] | inProcessProcSymbol | Symbol for this processing callback
  [in] | inProperties | A property map for this processing callback. The property map's values are copied by the host and associated with the new ProcessProc. The property map contents are unchanged and the map may be re-used when registering additional ProcessProcs.
  [in] | inInstanceInitProcSymbol | Initialization routine that will be called when a new instance of the Effect is created. Must be included in the same DLL as the main algorithm entrypoint. See Algorithm initialization.
  [in] | inBackgroundProcSymbol | Background routine that will be called in an idle context within the same address space as the associated process procedure. Must be included in the same DLL as the main algorithm entrypoint. See Background processing callback
  [out] | outProcID |

Todo:
  document this parameter

## ◆ AddMeters()

virtual AAX_Result AAX_IACFComponentDescriptor::AddMeters | ( | AAX_CFieldIndex | inFieldIndex,
|  | const AAX_CTypeID * | inMeterIDs,
|  | const uint32_t | inMeterCount
| ) |  |
| pure virtual

Adds a meter field to the plug-in's context.

Meter fields include an array of meter tap values, with one tap per meter per context. Only one meter field should be added per Component. Individual meter behaviors can be described at the Effect level.

For more information, see Plug-in meters .

Parameters

  [in] | inFieldIndex | Unique identifier for the field, generated using AAX_FIELD_INDEX
  [in] | inMeterIDs | Array of 32-bit IDs, one for each meter. Meter IDs must be unique within the Effect.
  [in] | inMeterCount | The number of meters included in this field

The documentation for this class was generated from the following file:

- AAX_IACFComponentDescriptor.h